using UnityEngine;
using System.Collections;

public class Companion : MonoBehaviour
{
	public float collectDistance;
	public float speed;
	public float lostHeight;
	
	public bool collected;
	
	public ForkingPath forkingPath;
	
	private Transform _player;
	private Rigidbody _rigidbody;
	
	private WordBalloons _wordBalloons;

	// Use this for initialization
	void Start ()
	{
		collected = false;
		_player = GameObject.FindGameObjectWithTag ( "Player" ).transform;
		_rigidbody = GetComponent <Rigidbody> ();
		_wordBalloons = GetComponent <WordBalloons> ();
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{
		
		if ( transform.position.y < lostHeight )
		{
			if ( forkingPath != null )
			{
				forkingPath.onCompanionLost ();
				collected = false;
			}
		}
		else
		{
			Vector3 delta = _player.transform.position - transform.position;
			
			if ( ! collected )
			{
				if ( delta.magnitude <= collectDistance )
				{
					collected = true;
					//_wordBalloons.ShowBalloon ( 0 );
				}
			}
			else
			{
				if ( delta.magnitude > 2.5f )
				{
					_rigidbody.AddForce ( delta * speed );
					_rigidbody.velocity = Vector3.ClampMagnitude ( _rigidbody.velocity, speed / 2 );
				}
				else
				{
					_rigidbody.velocity = Vector3.zero;
				}
			}
		}
	}
}

