using System;
using UnityEngine;
using System.Collections.Generic;

public class TileBlock
{
	public const float TILE_SIZE = 2f;
	
	public int width;
	public int depth;
	public Vector3 origin;
	public List <GameObject> tiles;
	
	public TileBlock ( Vector3 argOrigin, int argWidth, int argDepth )
	{
		origin = argOrigin;
		width = argWidth;
		depth = argDepth;
		tiles = new List <GameObject> ();
	}
	
	public Vector3 localToWorld ( int argX, int argZ )
	{
		return new Vector3 ( 
			( argX - ( width - 1f ) / 2f ) * TILE_SIZE,
			0f,
			( argZ ) * TILE_SIZE
		) +
		origin;
	}
	
	public void placeTile ( Transform argPrefab, int argX, int argZ, Color argColor )
	{
		GameObject tile = ( (Transform) GameObject.Instantiate ( 
			argPrefab, 
			localToWorld ( argX, argZ ), 
			Quaternion.identity * Quaternion.AngleAxis ( UnityEngine.Random.Range ( 0, 3 ) * 90, Vector3.up )
		) ).gameObject;
		
		tile.renderer.material.color = Color.Lerp ( argColor, Color.white, 0.75f );
		
		tiles.Add ( tile );
	}
}

