using System;
using UnityEngine;

public class Gene
{
	private const int MAX_WIDTH = 1;
	private const int MAX_HEIGHT = 2;
	
	public int type;
	public int width;
	public int height;
	public int x;
	public int y;
	public PathDefinition pathDefinition;
	public Color color;
	
	public Gene ( PathDefinition argPathDefinition )
	{
		pathDefinition = argPathDefinition;
		
		type = UnityEngine.Random.Range ( 0, PathDefinition.TILE_TYPES );
		width = 1;
		height = 1;
		x = UnityEngine.Random.Range ( 1, (int) pathDefinition.width );
		y = UnityEngine.Random.Range ( 1, (int) pathDefinition.height );
		color = new Color ( UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value );
	}
	
	public Gene mutate ()
	{
		Gene result = new Gene ( pathDefinition );
		
		result.type = type;
		result.width = mutateAttribute ( width, 1, 1, MAX_WIDTH );
		result.height = mutateAttribute ( height, 1, 1, MAX_HEIGHT );
		result.x = mutateAttribute ( x, 2, 0, (int) pathDefinition.width - 1 );
		result.y = mutateAttribute ( y, 2, 0, (int) pathDefinition.height - 1 );
		result.color = new Color (
			Mathf.Min ( Mathf.Max ( color.r + UnityEngine.Random.value * 0.1f, 0f ), 1f ),
			Mathf.Min ( Mathf.Max ( color.g + UnityEngine.Random.value * 0.1f, 0f ), 1f ),
			Mathf.Min ( Mathf.Max ( color.b + UnityEngine.Random.value * 0.1f, 0f ), 1f )
		);
		
		return result;
	}
	
	public Gene copy ()
	{
		Gene result = new Gene ( pathDefinition );
		result.type = type;
		result.width = width;
		result.height = height;
		result.x = x;
		result.y = y;
		
		return result;
	}
	
	private int mutateAttribute ( int argOriginal, int range, int argMin, int argMax )
	{
		return Mathf.Min ( Mathf.Max ( argOriginal + UnityEngine.Random.Range ( -range, range + 1 ), argMin ), argMax );
	}
}

